#!/usr/bin/python

"""

urlcontentchk.py

Simple script to verify that 'string' is in the website content.

Read the sites from ConfigFile in format:

url;string;emailtoalert
url;string;emailtoalert

Example:
www.google.com;Google;webmaster@null.net
www.google.com.ar;Google Argentina;webmaster@null.net

Use At Your Own Risk!

"""

__author__ = "storm"
__version__ = "0.5b"
__date__ = "Thu Oct  1 15:13:18 ART 2009"
__copyright__ = "Copyright (c) 2009 Storm"
__license__ = "GPL"

import os
import urllib
import smtplib

# File where the data will be stored
ConfigFile = "/usr/local/urlcontentchk/urlcontentchk.cfg"

# SMTP Server
SMTP_Server = "localhost"

# Function definition is here
def Banner():
	print "\n"
	print "-- urlcontentchk.py script"
	print "-- version 0.5b by Storm"
        print "\n"

def CheckContent( url, string ):
        "Check a site, looking for specified string"
	f = urllib.urlopen(url)
	UrlContent = f.read()
	if string in UrlContent:
		return True
	else:
		return False

def SendAlert( MailFrom, MailTo, url, string ):
	"Send email alert to the user"
	msg = ""  + "From: " + MailFrom
	msg = msg + "To: " + MailTo
	msg = msg + "Subject: urlcontentchk script ALERT\n"
	msg = msg + "\n"
	msg = msg + "\nALERT: String " + string + " not found on URL " + url + "."
	server=smtplib.SMTP(SMTP_Server)
	server.set_debuglevel(0)
	server.sendmail(MailFrom, MailTo, msg)
	server.quit()

#### MAIN
Banner()
for line in open(ConfigFile):
	record = line.split(";")
	CheckURL = record[0]
	CheckString = record[1]
	CheckEmail = record[2]
	site_content = CheckContent(CheckURL,CheckString)
	if site_content:
		print "URL: [" + CheckURL + "]\nString: [" + CheckString + "]\nStatus: OK\n"
	else:
		print "URL: [" + CheckURL + "]\nString: [" + CheckString + "]\nStatus: ERROR - Sending notification to " + CheckEmail
		SendAlert( CheckEmail, CheckEmail, CheckURL, CheckString )

### END!

